// TransformPatchRoisetsForMontage.ijm
// Julien Berro, Pollard lab, Yale University
// 9 September 2012

var ROIFileNamepattern="RoiSet";
addMembraneRoi=false; //default true
roisFromProjection=false; // true if the rois were collected from a sum projection image (prevents problems if the montage is then made with the hyperstack or multi-channels) //default true

 Dialog.create("Profiler parameters");
 Dialog.addString("Include Roisets starting with", ROIFileNamepattern) ;
Dialog.addCheckbox("Draw membrane for each roiset", addMembraneRoi);
Dialog.addCheckbox("Roisets were created on the projection movie", roisFromProjection);
Dialog.show();
ROIFileNamepattern=Dialog.getString();
addMembraneRoi=Dialog.getCheckbox();
roisFromProjection=Dialog.getCheckbox();


roiManager("Reset");
listFiles=getFileList(getDirectory("image"));
nbROIFiles=0;
for(i=0;i<listFiles.length;i++){// Counting the nb of ROIset files
	if(startsWith(listFiles[i],ROIFileNamepattern)&&endsWith(listFiles[i],".zip")){
		nbROIFiles++;
	}
}
tmpROINb=0;
setTool("line");
for(i=0;i<listFiles.length;i++){// Gets the length of each ROIset
	if(startsWith(listFiles[i],ROIFileNamepattern)&&endsWith(listFiles[i],".zip")){
		roiManager("Open", getDirectory("image")+listFiles[i]);
		curROINb=roiManager("count");
		sizeIndexesToDelete=curROINb-tmpROINb-2;
		indexesToDelete=newArray(sizeIndexesToDelete);
		for (j=0;j<sizeIndexesToDelete;j++){
			 indexesToDelete[j]=j+tmpROINb+1;
		}
		roiManager("select", indexesToDelete);
		roiManager("Delete");
		if (roisFromProjection&&Stack.isHyperstack){ // if the rois were taken from a projection image and want to make montage with hyperstack, need to update the frame positions 
			roiManager("select",tmpROINb);
			sl=getSliceNumber();
			Stack.setPosition(1, 1, sl);
			roiManager("Update");
			roiManager("select",tmpROINb+1);
			sl=getSliceNumber();
			Stack.setPosition(1, 1, sl);
			roiManager("Update");
		}
		if (addMembraneRoi){
			roiManager("select",tmpROINb);
			txt="Draw a line along the membrane \n";
			txt=txt+"When doing the montage, the image will be rotated \n such that the first point will end up on the upper left";
			run("To Selection");
run("Out [-]");
run("Out [-]");
run("Out [-]");
run("Out [-]");
			waitForUser("Membrane selection",txt);
			roiManager("Add");
			tmpROINb=roiManager("count");
			roiManager("Select",tmpROINb-1);
			roiManager("Rename", listFiles[i]);
		}
		tmpROINb=roiManager("count");
	}
}
if (addMembraneRoi) {
	imageDir=getDirectory("image");
	pathToSave=imageDir+"RoisForMontageWithMembrane.zip";
	roiManager("Deselect");
	roiManager("Save",pathToSave);
}
//runMacro("myProfilerToFile.ijm")
